<template>
  <div>
    <div>
      <div class="ml-4 text-h6">Договор</div>
      <div class="px-2">
        <q-checkbox @update:model-value="useDebounce(!main[0].check, 0)" :label="main[0].val" left-label  :model-value="main[0].check" v-model="main[0].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[1].check, 1)" :label="main[1].val" left-label  :model-value="main[1].check" v-model="main[1].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[2].check, 2)" :label="main[2].val" left-label  :model-value="main[2].check" v-model="main[2].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[3].check, 3)" :label="main[3].val" left-label  :model-value="main[3].check" v-model="main[3].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[4].check, 4)" :label="main[4].val" left-label  :model-value="main[4].check" v-model="main[4].check" size="lg" />
      </div>
    </div>
    <q-separator/>
    <div>
      <div class="ml-4 text-h6">Дело ведём в :</div>
      <div class="px-2">
        <q-checkbox @update:model-value="useDebounce(!main[5].check, 5)" :label="main[5].val" left-label  :model-value="main[5].check" v-model="main[5].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[6].check, 6)" :label="main[6].val" left-label  :model-value="main[6].check" v-model="main[6].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[7].check, 7)" :label="main[7].val" left-label  :model-value="main[7].check" v-model="main[7].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[8].check, 8)" :label="main[8].val" left-label  :model-value="main[8].check" v-model="main[8].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[9].check, 9)" :label="main[9].val" left-label  :model-value="main[9].check" v-model="main[9].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[10].check, 10)" :label="main[10].val" left-label  :model-value="main[10].check" v-model="main[10].check" size="lg" />
      </div>
    </div>
    <q-separator/>
    <div>
      <div class="ml-4 text-h6">Подготовить</div>
      <div class="px-2">
        <q-checkbox v-if="main[40]"  @update:model-value="useDebounce(!main[40].check, 40)" :label="main[40].val" left-label  :model-value="main[40].check" v-model="main[40].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[11].check, 11)" :label="main[11].val" left-label  :model-value="main[11].check" v-model="main[11].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[12].check, 12)" :label="main[12].val" left-label  :model-value="main[12].check" v-model="main[12].check" size="lg" />

        <q-checkbox v-if="main[42]"  @update:model-value="useDebounce(!main[42].check, 42)" :label="main[42].val" left-label  :model-value="main[42].check" v-model="main[42].check" size="lg" />
        <q-checkbox v-if="main[43]"  @update:model-value="useDebounce(!main[43].check, 43)" :label="main[43].val" left-label  :model-value="main[43].check" v-model="main[43].check" size="lg" />

        <q-checkbox  @update:model-value="useDebounce(!main[12].check, 12)" :label="main[12].val" left-label  :model-value="main[12].check" v-model="main[12].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[13].check, 13)" :label="main[13].val" left-label  :model-value="main[13].check" v-model="main[13].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[14].check, 14)" :label="main[14].val" left-label  :model-value="main[14].check" v-model="main[14].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[15].check, 15)" :label="main[15].val" left-label  :model-value="main[15].check" v-model="main[15].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[16].check, 16)" :label="main[16].val" left-label  :model-value="main[16].check" v-model="main[16].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[17].check, 17)" :label="main[17].val" left-label  :model-value="main[17].check" v-model="main[17].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[18].check, 18)" :label="main[18].val" left-label  :model-value="main[18].check" v-model="main[18].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[19].check, 19)" :label="main[19].val" left-label  :model-value="main[19].check" v-model="main[19].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[20].check, 20)" :label="main[20].val" left-label  :model-value="main[20].check" v-model="main[20].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[21].check, 21)" :label="main[21].val" left-label  :model-value="main[21].check" v-model="main[21].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[22].check, 22)" :label="main[22].val" left-label  :model-value="main[22].check" v-model="main[22].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[23].check, 23)" :label="main[23].val" left-label  :model-value="main[23].check" v-model="main[23].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[24].check, 24)" :label="main[24].val" left-label  :model-value="main[24].check" v-model="main[24].check" size="lg" />
        <q-checkbox v-if="main[44]"  @update:model-value="useDebounce(!main[44].check, 44)" :label="main[44].val" left-label  :model-value="main[44].check" v-model="main[44].check" size="lg" />
      </div>
    </div>
    <q-separator/>
    <div>
      <div class="ml-4 text-h6">Когда суд</div>
      <div class="px-2 my-4">
        <q-input @update:model-value="useDebounce(!main[35].check, 35)" :label="main[35].val" left-label  :model-value="main[35].val" v-model="main[35].val" type="textarea" :input-style="{height: '140px'}" />
      </div>
    </div>
    <q-separator/>
    <div>
      <div class="ml-4 text-h6">Матер.дела</div>
      <div class="px-2">
        <q-checkbox @update:model-value="useDebounce(!main[25].check, 25)" :label="main[25].val" left-label  :model-value="main[25].check" v-model="main[25].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[26].check, 26)" :label="main[26].val" left-label  :model-value="main[26].check" v-model="main[26].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[27].check, 27)" :label="main[27].val" left-label  :model-value="main[27].check" v-model="main[27].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[28].check, 28)" :label="main[28].val" left-label  :model-value="main[28].check" v-model="main[28].check" />
      </div>
    </div>
    <q-separator/>
    <div>
      <div class="ml-4 text-h6">Постановление</div>
      <div class="px-2">
        <q-checkbox  @update:model-value="useDebounce(!main[29].check, 29)" :label="main[29].val" left-label  :model-value="main[29].check" v-model="main[29].check" size="lg" />
        <q-input  @update:model-value="useDebounce(!main[30].check, 30)" :label="main[30].val" left-label  :model-value="main[30].val" v-model="main[30].val"  type="textarea" :input-style="{height: '140px'}"/>
        <q-checkbox  @update:model-value="useDebounce(!main[31].check, 31)" :label="main[31].val" left-label  :model-value="main[31].check" v-model="main[31].check" size="lg" />
        <q-checkbox  @update:model-value="useDebounce(!main[32].check, 32)" :label="main[32].val" left-label  :model-value="main[32].check" v-model="main[32].check" size="lg" />
      </div>
    </div>
    <q-separator/>
    <div>
      <div class="ml-4 text-h6">Описание</div>
      <div class="px-2">
        <q-input @update:model-value="useDebounce(!main[32].check, 33)" :label="main[33].val" :model-value="main[33].val" v-model="main[33].val" type="textarea" :input-style="{height: '140px'}"/>
        <q-checkbox @update:model-value="useDebounce(!main[33].check, 34)" :label="main[34].val" left-label  :model-value="main[34].check" v-model="main[34].check" size="lg" />
      </div>
    </div>
    <div v-if="main[36]">
      <div class="ml-4 text-h6">Подготовлено</div>
      <div class="px-2">
        <q-checkbox v-if="main[41]" @update:model-value="useDebounce(!main[41].check, 41)" :label="main[41].val" left-label  :model-value="main[41].check" v-model="main[41].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[36].check, 36)" :label="main[36].val" left-label  :model-value="main[36].check" v-model="main[36].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[37].check, 37)" :label="main[37].val" left-label  :model-value="main[37].check" v-model="main[37].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[38].check, 38)" :label="main[38].val" left-label  :model-value="main[38].check" v-model="main[38].check" size="lg" />
        <q-checkbox @update:model-value="useDebounce(!main[39].check, 39)" :label="main[39].val" left-label  :model-value="main[39].check" v-model="main[39].check" size="lg" />
      </div>
    </div>
    <q-btn label="поставить задачу о приеме" class="my-4 w-full" color="green">
      <q-menu>
        <div class="add-task">
          <div class="arena-date">
            <q-date v-model="date"
                    :q-date="date"
                    :model-value="date"
                    today-btn
                    :locale="myLocale"
                    dark
            />
          </div>
          <div class="arena-time">
            <p class="white-text text-left mx-auto my-4">Время</p>
            <input v-model="time" type="time"
                   min="00:00" max="24:00" width="50px" class="mb-4 mx-auto">
            <input @change="selectFile" type="file">
          </div>
          <div class="arena-btn">
            <div class="flex">
              <q-btn
                  label="Срочно"
                  color="red"
                  class="ml-auto mr-1 flex"
                  @click="quickly = !quickly"
                  :icon-right="quickly && 'check'||''"
              />
              <q-btn
                  label="Ок"
                  color="green"
                  class="mr-6 flex"
                  @click="sendMessage"
                  v-close-popup
              />
            </div>
          </div>
        </div>
      </q-menu>
    </q-btn>
  </div>
</template>

<script>
import {ref} from "vue";
import {useDebounce} from "../../components/useDebounce";
import {useUpdateLead} from "../../components/useUpdateLead";

export default {
  name: "Transfer",
  props: {
    _id: {type: String, required: true},
    transfer: {type: Array, required: true}
  },
  setup (props, {emit}) {

    const main = ref(props.transfer)

    const date = ref(new Date())
    const time = ref('')
    const file = ref({})
    const isFiles = ref(false)
    const quickly = ref(false)
    const selectFile = (event) => {
      file.value = event.target.files[0]
      isFiles.value = true
    }
    async function sendMessage (event) {
      emit('transferSendTask', {time: time.value, date: date.value, name: 'transfer', file: file.value, isFiles: isFiles.value, quickly: quickly.value})
    }

    return {
      main,
      useDebounce: useDebounce(async function (val, index) {
        await useUpdateLead({_id: props._id, key: 'transfer', value: main.value, log: 'Передача'})
      }, 800),
      sendMessage,

      quickly,
      date,
      time,
      file, selectFile,

      myLocale: {
        /* starting with Sunday */
        days: 'Воскресенье_Понедельник_Вторник_Среда_Четверг_Пятница_Суббота'.split('_'),
        daysShort: 'Вс_Пн_Вт_Ср_Чт_Пт_Сб'.split('_'),
        months: 'Январь_Февраль_Март_Апрель_Май_Июнь_Июль_Август_Сентябрь_Октябрь_Ноябрь_Декабрь'.split('_'),
        monthsShort: 'Янв_Фев_Мар_Апр_Май_Июн_Июл_Авг_Сен_Окт_Ноя_Дек'.split('_'),
        firstDayOfWeek: 1, // 0-6, 0 - Sunday, 1 Monday, ...
        format24h: true,
      }
    }
  }
}
</script>

<style scoped>

</style>